Public Class Drucktest

    Private m_RueckSeite As TB_Rueckseite
    Private m_VorderSeite As TB_Vorderseite

    
    Private Sub Drucktest_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        'Beim Laden der Windows Form alle notwendigen Variablen initialisieren
        m_RueckSeite = New TB_Rueckseite
        m_VorderSeite = New TB_Vorderseite

        'Seiteneinstellungen (Rnder und Orientierung) festlegen
        Dim m_PSettings As New Printing.PageSettings
        m_PSettings.Landscape = True
        With m_PSettings.Margins
            .Left = CInt(1.5 / 0.0254)
            .Right = CInt(1.5 / 0.0254)
            .Top = CInt(0.8 / 0.0254)
            .Bottom = CInt(0.8 / 0.0254)
        End With

        m_RueckSeite.DefaultPageSettings = m_PSettings
        m_VorderSeite.DefaultPageSettings = m_PSettings

        'Dem PageSetupDialog und dem PrintPreviewControl die anzuzeigende Seite bergeben
        Me.PageSetupDialog1.Document = m_VorderSeite
        Me.PrintPreviewControl1.Document = m_VorderSeite
        'Drucker anzeigen
        Me.TextBoxDrucker.Text = m_PSettings.PrinterSettings.PrinterName
    End Sub

    Private Sub TrackBar1_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TrackBar1.Scroll
        Me.PrintPreviewControl1.Zoom = TrackBar1.Value / 100
    End Sub

    Private Sub ButtonAktualisieren_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonAktualisieren.Click
        If Not CheckBoxRueckseite.Checked Then Exit Sub

        'Fr die Rckseite die Startziffer der zu druckenden Mitglieds-Nummern angeben
        Try
            Dim Nummer As Integer = TextBoxStartNummer.Text
            m_RueckSeite.Startnummer = Nummer
            Me.PrintPreviewControl1.InvalidatePreview()
        Catch ex As Exception

        End Try
    End Sub

    Private Sub ButtonDrucken_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonDrucken.Click
        If Me.CheckBoxRueckseite.Checked Then
            'Beim Drucken der rckseite zuvor angeben, dass diese um 180 Grad gedreht werden soll
            m_RueckSeite.Drehen = True
            m_RueckSeite.Print()
            m_RueckSeite.Drehen = False
        Else
            m_VorderSeite.Print()
        End If
      
    End Sub

    Private Sub ButtonFertig_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonFertig.Click
        'Form schlieen
        Me.Close()
    End Sub

    Private Sub ButtonEinstellungen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonEinstellungen.Click

        'Seiten-Einstellungen-Dialog anzeigen
        PageSetupDialog1.ShowNetwork = False
        PageSetupDialog1.AllowOrientation = False
        PageSetupDialog1.EnableMetric = True

        'Wenn im Seiteneinstellungs-Dialog OK ausgewhlt wurde,
        If PageSetupDialog1.ShowDialog = Windows.Forms.DialogResult.OK Then
            'Seiten- und Druckereinstellungen fr die zu druckenden Seiten bernehmen
            m_RueckSeite.DefaultPageSettings = PageSetupDialog1.PageSettings
            m_VorderSeite.DefaultPageSettings = PageSetupDialog1.PageSettings
            m_RueckSeite.PrinterSettings = PageSetupDialog1.PrinterSettings
            m_VorderSeite.PrinterSettings = PageSetupDialog1.PrinterSettings

            Me.TextBoxDrucker.Text = PageSetupDialog1.PrinterSettings.PrinterName
            Me.PrintPreviewControl1.InvalidatePreview()
        End If
    End Sub

    Private Sub CheckBoxRueckseite_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBoxRueckseite.CheckedChanged
        'Wechsel zwische Rck-und Vorderseite
        If CheckBoxRueckseite.Checked Then
            Me.TextBoxStartNummer.Enabled = True
            Me.Label1.Enabled = True
            Me.ButtonAktualisieren.Visible = True
            Me.PrintPreviewControl1.Document = m_RueckSeite
        Else
            Me.TextBoxStartNummer.Enabled = False
            Me.Label1.Enabled = False
            Me.ButtonAktualisieren.Visible = False
            Me.PrintPreviewControl1.Document = m_VorderSeite
        End If
        'Anzeige im PrintPreviewControl aktualisieren
        Me.PrintPreviewControl1.InvalidatePreview()
    End Sub
End Class