Imports System.Drawing
Imports System.Drawing.Drawing2D
Public Class TB_Rueckseite
    Inherits Printing.PrintDocument

    Private m_Startnummer As Integer = 1
    Public Drehen As Boolean = False

    Property Startnummer() As Integer
        Get
            Return m_Startnummer
        End Get
        Set(ByVal Value As Integer)
            m_Startnummer = Value
        End Set
    End Property


    Private Sub TB_Rckseite_PrintPage(ByVal sender As Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs) Handles MyBase.PrintPage


        Dim g As Graphics = e.Graphics

        'die ganze Grafik wird um 180 Grad gedreht, wenn die Rckseite gedruckt werden soll
        '(nicht fr die Druck-Vorschau, sondern nur eben whrend des Druckens notwendig.
        'wird nach dem Drucken wieder zurckgestellt, damit im PrintPreview alles wieder normal aussieht)
        If Drehen Then
            g.TranslateTransform((e.MarginBounds.Left + e.MarginBounds.Width), (e.MarginBounds.Top + e.MarginBounds.Height))
            g.RotateTransform(180)
            g.TranslateTransform((-e.MarginBounds.Left), (-e.MarginBounds.Top))
        End If

        Dim RealDruckBreite As Single = e.MarginBounds.Width
        Dim RealDruckHoehe As Single = e.MarginBounds.Height

        Dim DistLinks As Integer = e.MarginBounds.Left
        Dim DistOben As Integer = e.MarginBounds.Top


        'Ich arbeite mit eigenen Koordinaten:
        'Ein Ausweis soll etwa 7cm breit und 10cm hoch sein,
        'also passen auf ein A4-Blatt vier Ausweise nebeneinander und zwei untereinander
        'Somit brauche ich ein Rechteck von 28cm Breite und 20cm Hhe
        'Natrlich wird die Seite nicht 28*20 cm gross sein, also muss skaliert werden
        'also erst einmal das optimal skalierte Rechteck und den zugehrigen Skalierungsfaktor ermitteln:


        Dim EigeneBildBreite As Single = 28.0F
        Dim EigeneBildHoehe As Single = 20.0F


        Dim Factor As Double
        If EigeneBildBreite / EigeneBildHoehe > RealDruckBreite / RealDruckHoehe Then
            Factor = RealDruckBreite / EigeneBildBreite
        Else
            Factor = RealDruckHoehe / EigeneBildHoehe
        End If

        'Wenn ich jetzt also beliebige "eigene" Bildbreiten und -Hhen sowie -Positionen 
        'mit diesem Faktor multipliziere, komme ich auf die "Druck" -Bildbreiten, -Hhen und -Positionen
        'Halt: Bercksichtigt werden muss noch Distanz links und Distanz oben 
        'Diese Abstnde mssen zu den "Druck" -Bildbreiten, -Hhen und -Positionen addiert werden
        '(das skalierte Rechteck, in dem die Ausweise gedruckt werden, ist ja etwas kleiner 
        'als das maximal mgliche, durch die Seitenrnder vorgegebene Druckrechteck)
        DistLinks += CInt((CSng(RealDruckBreite) - Factor * CSng(EigeneBildBreite)) / 2.0F)
        DistOben += CInt((CSng(RealDruckHoehe) - Factor * CSng(EigeneBildHoehe)) / 2.0F)

        'So, jetzt kann die Ausweisbreite und -hhe in Pixeln ermittelt werden
        Dim Ausweisbreite As Integer = (28.0F * Factor) \ 4
        Dim Ausweishoehe As Integer = (20.0F * Factor) \ 2

        'Eigentlich bracht nur der Platz fr die Ausweise mit einem Hintergrund-Muster ausgefllt werden
        'Hintergund-Muster zeichnen
        Dim br As New HatchBrush(HatchStyle.Percent30, Color.DarkGreen, Color.LightGray)
        g.FillRectangle(br, New Rectangle(DistLinks, DistOben, Ausweisbreite * 4, Ausweishoehe * 2))

        'Ressource frei geben
        br.Dispose()


        'Das Bild, das verkleinert im Hintergrund des Ausweises gezeichnet werden soll
        'Es soll folgende Position / Abmessungen haben (Links; Oben; Breite; Hhe) in cm:
        '(5; 7; 1,5; 2)
        Dim Bild As Image = My.Resources.nurbaeume
        Dim BildRechteck As New RectangleF(5.0F * Factor, 7.0F * Factor, 1.5F * Factor, 2.0F * Factor)

        'unterschiedlich groe Fonts zum Zeichnen der Texte
        Dim Ft1 As Font = New Font("Arial", 12, FontStyle.Bold)
        Dim Ft2 As Font = New Font("Arial", 10, FontStyle.Regular)
        Dim Ft3 As Font = New Font("Arial", 8, FontStyle.Regular)

        'Textdarstellung auf ClearType einstellen
        g.TextRenderingHint = Text.TextRenderingHint.ClearTypeGridFit

        'Pen zum Zeichnen der gepunkteten Linien
        Dim DotPen As New Pen(Color.Black)
        DotPen.DashStyle = DashStyle.Dot

        'Der Zhler fr die anzuzeigenden Mitglieds-Nummern
        Dim Zaehler As Integer = m_Startnummer

        'Jetzt knnen Ausweis-Inhalte Spalten- und zeilenweise gezeichnet werden:
        For I As Integer = 0 To 3
            Dim TmpLeft As Integer = DistLinks + Ausweisbreite * I
            For J As Integer = 0 To 1
                Dim TmpTop As Integer = DistOben + Ausweishoehe * J

                'Dieses Rechteck (RA) enthlte erst mal die Grenzen eines Ausweises
                Dim RA As New Rectangle(TmpLeft, TmpTop, Ausweisbreite, Ausweishoehe)

                'jetzt soll das Rechteck mit abgerundeten Rndern gezeichnet werden
                'Es soll etwa 6,2 * 8,4cm gross sein und (li/o) 0,4 bzw. 0,8 cm vom Rand abstehen
                Dim RundRechteck As New Rectangle(RA.Left + 0.4F * Factor, RA.Top + 0.8F * Factor, 6.2F * Factor, 8.4F * Factor)


                'Gradient-Brush festlegen
                Dim Brsh As New LinearGradientBrush(RundRechteck, Color.White, Color.LightGray, LinearGradientMode.BackwardDiagonal)
                'Die Rundung am Rechteck soll etwa 1cm Durchmesser haben,
                'runden GraphicsPath ermitteln
                Dim gp As GraphicsPath = Rundpfad_liefern(RundRechteck, CInt(1.0F * Factor))
                'Rundrechteck-Pfad mit Gradienten fllen
                g.FillPath(Brsh, gp)
                'goldenes Rundrechteck zeichnen
                g.DrawPath(Pens.Gold, gp)

                'Ressourcen frei geben
                Brsh.Dispose()
                gp.Dispose()

                'Bild zeichnen
                g.DrawImage(Bild, TmpLeft + BildRechteck.Left, TmpTop + BildRechteck.Top, BildRechteck.Width, BildRechteck.Height)

                Dim Breite As Integer = RundRechteck.Width
                Dim Zentrieren As Boolean = True
                Dim LiPos As Integer = RundRechteck.Left

                Text_Zeichnen(g, Ft1, Breite, Zentrieren, LiPos, TmpTop + 1.0F * Factor, "Heimatverein")
                Text_Zeichnen(g, Ft1, Breite, Zentrieren, LiPos, TmpTop + 1.5F * Factor, Chr(34) & "Zwei Tannen" & Chr(34) & " e.V.")
                Text_Zeichnen(g, Ft1, Breite, Zentrieren, LiPos, TmpTop + 2.0F * Factor, "Titschendorf")
                Text_Zeichnen(g, Ft2, Breite, Zentrieren, LiPos, TmpTop + 2.7F * Factor, "- Mitgliedskarte -")

                Zentrieren = False
                LiPos += 1.0F * Factor

                Text_Zeichnen(g, Ft3, Breite, Zentrieren, LiPos, TmpTop + 5.0F * Factor, "Mitgliedsnummer")
                Text_Zeichnen(g, Ft3, Breite, Zentrieren, LiPos, TmpTop + 6.2F * Factor, "Name, Vorname")
                Text_Zeichnen(g, Ft3, Breite, Zentrieren, LiPos, TmpTop + 7.4F * Factor, "Eintrittsdatum")
                Text_Zeichnen(g, Ft3, Breite, Zentrieren, LiPos, TmpTop + 8.6F * Factor, "Unterschrift")

                LiPos = RundRechteck.Left + 0.8F * Factor
                Dim RePos As Integer = RundRechteck.Right - 0.8F * Factor

                Line_Zeichnen(g, DotPen, LiPos, RePos, TmpTop + 5.0F * Factor)
                Line_Zeichnen(g, DotPen, LiPos, RePos, TmpTop + 6.2F * Factor)
                Line_Zeichnen(g, DotPen, LiPos, RePos, TmpTop + 7.4F * Factor)
                Line_Zeichnen(g, DotPen, LiPos, RePos, TmpTop + 8.6F * Factor)

                'Mitgliedsnummer zeichnen
                Text_Zeichnen(g, Ft1, Breite, True, RundRechteck.Left, TmpTop + 4.4F * Factor, Zaehler.ToString.PadLeft(5, "0"))

                Zaehler += 1
            Next
        Next
        'Anmerkung: Man kann's natrlich auch anders machen 
        'Erst ein Bitmap mit Ausweis-Gre erstellen, und dessen Graphics-Objekt benutzen um darauf zu 
        'zeichnen
        'Dann dieses Bitmap zeilen- und spaltenweise auf das hier aktuelle Graphics-Objekt zeichnen

        'Ressourcen frei geben
        DotPen.Dispose()

        Dim GPen As New Pen(Color.Gray)
        g.SmoothingMode = SmoothingMode.None

        'graue Linien zum Auseinanderschneiden der Ausweise zeichnen
        For I As Integer = 0 To 2
            Dim TopPos As Integer = DistOben + Ausweishoehe * I
            g.DrawLine(GPen, DistLinks, TopPos, DistLinks + Ausweisbreite * 4, TopPos)
        Next

        For I As Integer = 0 To 4
            Dim LeftPos As Integer = DistLinks + Ausweisbreite * I
            g.DrawLine(GPen, LeftPos, DistOben, LeftPos, DistOben + Ausweishoehe * 2)
        Next

        'Ressourcen frei geben
        GPen.Dispose()
    End Sub
    Private Sub Line_Zeichnen(ByVal g As Graphics, ByVal Pn As Pen, ByVal Left As Integer, ByVal Right As Integer, ByVal Top As Integer)
        'zeichnet eine waagerechte Linie
        g.DrawLine(Pn, Left, Top, Right, Top)
    End Sub
    Private Sub Text_Zeichnen(ByVal g As Graphics, ByVal Ft As Font, ByVal Width As Integer, ByVal Zentriert As Boolean, ByVal Left As Integer, ByVal Top As Integer, ByVal Text As String)
        Dim LinksPos As Integer = Left

        If Zentriert Then
            'Mit MeasureString die Breite des zu zeichnenden Textes und 
            'damit seine linke Position ermitteln
            LinksPos += (Width - g.MeasureString(Text, Ft).Width) \ 2
        End If

        g.DrawString(Text, Ft, Brushes.Black, LinksPos, Top)
    End Sub

    Private Function Rundpfad_liefern(ByVal RE As Rectangle, ByVal Rundung As Single) As GraphicsPath
        'liefert einen GraphicsPath mit abgerundeten Ecken fr ein gegebenes Rechteck 
        Dim Path As New GraphicsPath

        Dim xre(3) As Rectangle, i As Integer
        For i = 0 To 3
            xre(0) = New Rectangle(RE.Left, RE.Top, Rundung, Rundung)
            xre(1) = New Rectangle(RE.Right - Rundung, RE.Top, Rundung, Rundung)
            xre(2) = New Rectangle(RE.Right - Rundung, RE.Bottom - Rundung, Rundung, Rundung)
            xre(3) = New Rectangle(RE.Left, RE.Bottom - Rundung, Rundung, Rundung)
        Next

        Path = New GraphicsPath
        Path.StartFigure()

        Path.AddArc(xre(3), 90, 90)
        Path.AddArc(xre(0), 180, 90)
        Path.AddArc(xre(1), 270, 90)
        Path.AddArc(xre(2), 0, 90)

        Path.CloseFigure()

        Return Path
    End Function

End Class
