Imports System.Drawing
Imports System.Drawing.Drawing2D
Public Class TB_Vorderseite
    Inherits Printing.PrintDocument



    Private Sub TB_Vorderseite_PrintPage(ByVal sender As Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs) Handles MyBase.PrintPage
        Dim g As Graphics = e.Graphics

        'Das Rechteck, in dem gedruckt werden kann, hngt ab von den 
        'Seitenrand-Einstellungen des Druckers
        'Und es ist daran zu denken, dass im Querformat gedruckt werden soll
        Dim RealDruckBreite As Single = e.MarginBounds.Width
        Dim RealDruckHoehe As Single = e.MarginBounds.Height

        Dim DistLinks As Integer = e.MarginBounds.Left
        Dim DistOben As Integer = e.MarginBounds.Top

        'Meine zuknftige Grafik soll am besten die Abmessungen (b*h) 28cm*20cm haben
        Dim EigeneBildBreite As Single = 28.0F
        Dim EigeneBildHoehe As Single = 20.0F

        'Faktor gibt an, mit welcher Skalierung mein Rechteck (28*20) 
        'auf das Druckrechteck projeziert wird
        Dim Factor As Double
        If EigeneBildBreite / EigeneBildHoehe > RealDruckBreite / RealDruckHoehe Then
            Factor = RealDruckBreite / EigeneBildBreite
        Else
            Factor = RealDruckHoehe / EigeneBildHoehe
        End If

        'Wenn ich jetzt also beliebige "eigene" Bildbreiten und -Hhen sowie -Positionen 
        'mit diesem Faktor multipliziere, komme ich auf die "Druck" -Bildbreiten, -Hhen und -Positionen
        'Halt: Bercksichtigt werden muss noch DistLinks und DistOben 
        'Diese Abstnde mssen zu den "Druck" -Bildbreiten, -Hhen und -Positionen addiert werden
        DistLinks += CInt((CSng(RealDruckBreite) - Factor * CSng(EigeneBildBreite)) / 2.0F)
        DistOben += CInt((CSng(RealDruckHoehe) - Factor * CSng(EigeneBildHoehe)) / 2.0F)

        'Auf dem Blatt Papier sollen vier Ausweise nebeneinander in zwei Zeilen stehen
        'Inzwischen kann die Ausweisbreite und -hhe in Pixeln ermittelt werden
        Dim Ausweisbreite As Integer = (28.0F * Factor) \ 4
        Dim Ausweishoehe As Integer = (20.0F * Factor) \ 2


        'so, jetzt haben wir also die Skalierung und die Rnder, Hhe und Breite zum Drucken

        'Das Bild, das gezeichnet werden soll
        Dim Bild As Image = My.Resources.zweiTannen
        'Dieses Bild soll zum Schluss etwa 5 cm hoch sein und mittig stehen
        Dim BildDruckHoehe As Single = 5.0F * Factor
        Dim Bildskalierung As Single = Bild.Height / BildDruckHoehe
        Dim BildDruckBreite As Single = Bild.Width / Bildskalierung


        Dim BildDruckRandLinks As Single = (Ausweisbreite - BildDruckBreite) / 2.0F
        Dim BildDruckRandOben As Single = (Ausweishoehe - BildDruckHoehe) / 2.0F


        'Hintergund-Muster zeichnen
        Dim br As New HatchBrush(HatchStyle.Percent30, Color.DarkGreen, Color.LightGray)
        g.FillRectangle(br, e.Graphics.ClipBounds)

        Dim TempLeft As Single
        Dim TempTop As Single

        For I As Integer = 0 To 3
            TempLeft = DistLinks + BildDruckRandLinks + Ausweisbreite * CSng(I)
            For J As Integer = 0 To 1
                TempTop = DistOben + BildDruckRandOben + Ausweishoehe * CSng(J)
                g.DrawImage(Bild, TempLeft, TempTop, BildDruckBreite, BildDruckHoehe)
            Next
        Next

        'Ressourcen frei geben
        br.Dispose()
        Bild.Dispose()

    End Sub

End Class
